###########################################################################
## Application results using R packages
###########################################################################
### Clear R environment
rm(list=ls(all=TRUE))

# read in
setwd("/Users/vishal/Documents/RESEARCH/Working Paper/RDD_Perm/Application_round2/results_R")

# data to use
tabletwo <- read.dta13("table_two.dta")

source("functions.R")
source("rdbwselect.R")
source("DRDfunctions.R")
source("rdrobust.R")


# DEMSHAREPREV

rdrobust(y=tabletwo[which(tabletwo$use==1),]$demshareprev,
         x=tabletwo[which(tabletwo$use==1),]$difdemshare, h=0.1878,b=0.1878)

daty= tabletwo[which(tabletwo$use==1),]$demshareprev
datx = tabletwo[which(tabletwo$use==1),]$difdemshare
ygrid=quantile(daty,seq(0.001,0.999,length.out=999))
N=length(daty)
smooth=4.5
mrdbw.out = rdbwselect(y=tabletwo[which(tabletwo$use==1),]$demshareprev,
                       x=tabletwo[which(tabletwo$use==1),]$difdemshare, bwselect="CCT")
bw_mrd=mrdbw.out$bws[1,1]*N^(1/5-1/smooth)
results<-DRDtest(daty,
                 datx,ygrid, h=bw_mrd, bwsel = "CCT",undersmooth=smooth)
drdresults <-c(DRDpvalue(max(abs(results$ksstat_iter)),side=2))



# DEMWINPREV

rdrobust(y=tabletwo[which(tabletwo$use==1),]$demwinprev,
         x=tabletwo[which(tabletwo$use==1),]$difdemshare, h=0.1497,b=0.1497)

# DEMOFFICEEXP

rdrobust(y=tabletwo[which(tabletwo$use==1),]$demofficeexp,
         x=tabletwo[which(tabletwo$use==1),]$difdemshare, h=0.1932, b=0.1932)

# OTHOFFICEEXP

rdrobust(y=tabletwo[which(tabletwo$use==1),]$othofficeexp,
         x=tabletwo[which(tabletwo$use==1),]$difdemshare, h=0.1877, b=0.1877)

# DEMELECTEXP

rdrobust(y=tabletwo[which(tabletwo$use==1),]$demelectexp,
         x=tabletwo[which(tabletwo$use==1),]$difdemshare, h=0.1958, b=0.1958)

# OTHELECTEXP

rdrobust(y=tabletwo[which(tabletwo$use==1),]$othelectexp,
         x=tabletwo[which(tabletwo$use==1),]$difdemshare, h=0.1875, b=0.1875)





